import typing
from abc import ABC, abstractmethod

from tottle.http import ABCSessionManager

if typing.TYPE_CHECKING:
    from tottle.api.request_rescheduler.abc import ABCRequestRescheduler


class ABCAPI(ABC):
    http: ABCSessionManager
    ignore_errors: bool
    request_rescheduler: "ABCRequestRescheduler"

    @abstractmethod
    async def request(
        self,
        method: str,
        data: typing.Optional[dict] = None,
    ) -> typing.Optional[typing.Any]:
        pass
