import typing
from abc import ABC, abstractmethod

if typing.TYPE_CHECKING:
    from tottle.api import ABCAPI, API


class ABCResponseValidator(ABC):
    @abstractmethod
    async def validate(
        self,
        method: str,
        data: dict,
        response: typing.Any,
        ctx_api: typing.Union["ABCAPI", "API"],
    ) -> typing.Union[typing.Any, typing.NoReturn]:
        pass
