import typing

from tottle.exception_factory import TGAPIError
from tottle.api.response_validator.abc import ABCResponseValidator

if typing.TYPE_CHECKING:
    from tottle.api import ABCAPI, API


class TGAPIErrorResponseValidator(ABCResponseValidator):
    async def validate(
        self,
        method: str,
        data: dict,
        response: typing.Any,
        ctx_api: typing.Union["ABCAPI", "API"],
    ) -> typing.Union[typing.Any, typing.NoReturn]:
        if response.get("ok"):
            return response.get("result")

        code, msg = response.get("error_code"), response.get("description")

        if ctx_api.ignore_errors:
            return None

        raise TGAPIError(code, msg, response)
