import typing
from abc import ABC, abstractmethod


class ABCHandler(ABC):
    blocking: bool = False

    @abstractmethod
    async def filter(self, update: typing.Any) -> typing.Union[dict, bool]:
        pass

    @abstractmethod
    async def handle(self, update: typing.Any, **context) -> typing.Any:
        pass
