import typing
from abc import ABC

if typing.TYPE_CHECKING:
    from tottle.dispatch.views.abc import ABCView
    from tottle.dispatch.handlers import ABCHandler

MiddlewareResponse = typing.NewType("MiddlewareResponse", bool)


class BaseMiddleware(ABC):
    async def pre(self, update):
        ...

    async def post(
        self,
        update,
        view: "ABCView",
        handle_responses: typing.List[typing.Any],
        handlers: typing.List["ABCHandler"],
    ):
        ...

    def __repr__(self) -> str:
        return f"<{self.__class__.__name__}>"
