from abc import ABC, abstractmethod
from typing import Union, Type

from tottle.types.updates.base import BaseBotUpdate


class ABCRule(ABC):
    config: dict = {}

    @classmethod
    def with_config(cls, config) -> Type["ABCRule"]:
        cls.config = config
        return cls

    @abstractmethod
    async def check(self, update: BaseBotUpdate):
        pass
