import typing
from abc import ABC, abstractmethod

from tottle.types.methods import *
from tottle.types.methods import chat

if typing.TYPE_CHECKING:
    from tottle.api import API


class APICategories(ABC):
    @property
    def chats(self) -> chat.ChatCategory:
        return chat.ChatCategory(self.api_instance)

    @property
    def messages(self) -> message.MessageCategory:
        return message.MessageCategory(self.api_instance)

    @property
    def users(self) -> user.UserCategory:
        return user.UserCategory(self.api_instance)

    @property
    @abstractmethod
    def api_instance(self) -> "API":
        pass
