from .base import Base
from ..objects import user


class UserCategory(Base):
    async def get_me(self, **kwargs) -> user.User:
        params = self.get_set_params(locals())
        response = await self.api.request("getMe", params)
        return user.User(**response)

    async def log_out(self, **kwargs) -> bool:
        params = self.get_set_params(locals())
        response = await self.api.request("logOut", params)
        return response

    async def close(self, **kwargs) -> bool:
        params = self.get_set_params(locals())
        response = await self.api.request("close", params)
        return response
