from pydantic import BaseModel
from typing import Optional


class ShippingAddress(BaseModel):
    country_code: Optional[str] = None
    state: Optional[str] = None
    city: Optional[str] = None
    street_line1: Optional[str] = None
    street_line2: Optional[str] = None
    post_code: Optional[str] = None


class OrderInfo(BaseModel):
    name: Optional[str] = None
    phone_number: Optional[str] = None
    email: Optional[str] = None
    shipping_address: Optional[ShippingAddress] = None
