from typing import Optional, List

from pydantic import BaseModel


class PassportFile(BaseModel):
    file_id: Optional[str] = None
    file_unique_id: Optional[str] = None

    file_size: Optional[int] = None
    file_date: Optional[int] = None


class EncryptedPassportElement(BaseModel):
    type: Optional[str] = None
    data: Optional[str] = None
    phone_number: Optional[str] = None
    email: Optional[str] = None
    files: Optional[List[PassportFile]] = None

    front_side: Optional[PassportFile] = None
    reverse_side: Optional[PassportFile] = None
    selfie: Optional[PassportFile] = None
    translation: Optional[PassportFile] = None

    hash: Optional[str] = None


class EncryptedCredentials(BaseModel):
    data: Optional[str] = None
    hash: Optional[str] = None
    secret: Optional[str] = None


class PassportData(BaseModel):
    data: Optional[List[EncryptedPassportElement]] = None
    credentials: Optional[EncryptedCredentials] = None
