from typing import Optional, List

from pydantic import BaseModel

from .user import User
from tottle.types.objects.entity import Entity


class PollAnswer(BaseModel):
    poll_id: Optional[str] = None
    user: Optional[User] = None
    option_ids: Optional[List[int]] = None


class PollOption(BaseModel):
    text: Optional[str] = None
    voter_count: Optional[int] = None


class Poll(BaseModel):
    id: Optional[str] = None
    question: Optional[str] = None
    options: Optional[List[PollOption]] = None
    total_voter_count: Optional[int] = None
    is_closed: Optional[bool] = None
    is_anonymous: Optional[bool] = None
    type: Optional[str] = None
    allows_multiple_answers: Optional[bool] = None
    correct_option_id: Optional[int] = None
    explanation: Optional[str] = None
    explanation_entities: Optional[List[Entity]] = None
    open_period: Optional[int] = None
    close_date: Optional[int] = None
