from typing import Optional

from pydantic import BaseModel

from tottle.types.objects.photo import PhotoSize


class Video(BaseModel):
    file_id: Optional[str] = None
    file_unique_id: Optional[str] = None
    file_size: Optional[int] = None

    width: Optional[int] = None
    height: Optional[int] = None
    duration: Optional[int] = None

    thumb: Optional[PhotoSize] = None
    mime_type: Optional[str] = None


class VideoNote(BaseModel):
    file_id: Optional[str] = None
    file_unique_id: Optional[str] = None
    file_size: Optional[int] = None

    length: Optional[int] = None
    duration: Optional[int] = None
    thumb: Optional[PhotoSize] = None
